url: smolrant.html
date: 2022-12-16
title: Smol Rant
author: Rahul Jha
tags: machine learning, efficiency, rant
summary: {insert words} of me making no sense.

### Prologue
I am an idiot, and while that may not come as a surprise to the vast majority of my audience, let me <strike>elaborate</strike> nerd out. When I am done nerding out, I may write about some brand new _fresh_ ideas, but I make no promises. Not because I believe in the sanctity of promises but because I do not check the prologue before committing the post to my repository - and consequently to the our generations collective memory. 

### Large Language Models, Larger Problems
I am supposed to be working on something that involves using transformers. A transformer is a cool neural network that is especially suited to tasks related to natural language processing. Some of my friends (I know them they don't know me so half-friends?) also believe they can do all sorts of magical things, like helping me find a girlfriend (Bumble as failed, more on that later), but I digress (a decoder spitting out the most immaculate love letters may be something I'm open to working on, for the record). Now training a transformer is a very expensive process - Google reportedly spent north of 12 million USD on training [Bert](https://huggingface.co/blog/bert-101) on a corpus of 11 million articles and the entirety of Wikipedia - so most people just use pre-trained models. Pre trained models are unusually effective on a myriad of tasks but it is always possible to fine-tune (overfit sounds scary) them on specific training data. Hugging Face, who go by just the emoji 🤗, have a fine-ass [tutorial](https://huggingface.co/docs/transformers/training) and I decided to replicate that on colab. Now this was a stupid idea for two reasons: 
- The dataset I was working with has been extensively studied and smarter people with petabytes of RAM have published fine-tuned transformers for peasants like me.
- These transformers can be HUGE and I naively assumed Colab had unlimited RAM.
7 disconnected runtimes and countless errors later, I managed to coax Kaggle's runtime into _running_ the training loop, but there's no guarantee that the model will be fine tuned when I wake up tomorrow (the ETA is 7 hours as of 16-12-22 23:07). I could've just picked up a fine tuned model and then done some data cleaning. It would've made my coordinators proud.

### Why Semantic Search is Bad
Ever wondered how Spotify's song radio doesn't totally suck? How Gumaan is always followed by Afsanay and not Baazigar? This is because they employ something called semantic search to queue songs. They are also big time philanthropists (I am legally obliged to say good things about them till my discounted subscription expires) and have open-sourced the library they used for the greater good. It's called [ANNOY](https://github.com/spotify/annoy), short for Approximate Nearest Neighbors Oh Yeah (the developer was a man of culture, and yet my contemporaries look down upon my Gitlab group name). The aforementioned something I am working on also needs to efficiently look up stuff most relevant to queries, and I thought ANN would be a great way of doing that. The only problem - at the scale I require, exact search is as fast as ANN search and ANN search just doesn't cut it. Of course I was knee deep into implementing ANN search when I realised that. As a result I now have two colab notebooks and multiple binary indices that are of no use to me. I guess I'll just share them for the greater good. [ANNOY Indexing](https://colab.research.google.com/drive/1uhQFzWPAkTFg17hiXucHA4VbRFmMob4m?usp=sharing) [FAISS Indexing](https://colab.research.google.com/drive/1o8ET707NVi3BXrvydEL5ZAfLYlhyg0UB?usp=sharing). I had to abandon these works for art for obvious reasons.

### Why I love Silicon Valley
[Silicon Valley](https://www.wikiwand.com/en/Silicon_Valley_(TV_series)) is the greatest thing to happen to me in 2022. And I learnt math from someone with Erdos number 2 so you know how cool Silicon Valley is. Silicon Valley is Big Bang Theory, if it was actually funny. It is like Brooklyn 99, if Jake Peralta was a systems chad. It is like, well you get the idea. Now men of culture who read me know that the premise of the show, so to say, is a revolutionary compression algorithm. It optimizes the [tip-to-tip](https://www.imdb.com/title/tt3557358/) efficiency. The jerk-off jokes got me interested, the intense drama kept me hooked. This section of the blogpost does not have a logical ending, like most lives. Watch it to set the stage for intense-ass discussions with me.

### Idea-1
I do not like Javascript because I do not like a lot of things/people. I do not use Javascript because while I can find my way through a script, I do not enjoy the process. This has been a great deterrent because (surprise surprise) this blog is hosted on the web and most web browsers have a weird fixation with Javascript. I have since worked on a small-ish Javascript project and am open to including dirty JS scripts on this blog. Sure I will be messing with my morals, but when have morals done anyone any good. Also, using Javascript on the piece of art this blog is will allow me to encrypt blog posts _en route_. I have a lot of poorly written blog posts that do not appear on the home page because their quality has somehow managed to fall below even my (abysmal) standards. When I want _the right_ people to read these posts, I just share the links with them. But I am paranoid, and I am scared about the proliferation of links. With javascript and online encryption, I can share these links with friends, and then implement some sort of OTP mechanism. Cache of encrypted amorous epistles coming your way. Meanwhile, a hint for people who want to read the easter eggs : Nagpur.

### Idea-2
Remember semantic search from like 2 sections above? Remember my Instagram [search idea](https://juggernautjha.gitlab.io/c17e/posts/udta_ghoda.html)? What if someone (admittedly a lot smarter than me) combines those? Imagine a locally hosted nearest neighbours search?

### Born Too Late for Bumble
I recently installed Bumble because I was bored (big surprise) and I wanted to inspect-element. I figured out a way of downloading pictures of people _next_ in the row. But without names they are of no use to me. Can someone suggest a better way? Also I swiped left on the one person who swiped right on me and Bumble was kind enough to let me know as soon as I swiped. Life is hard. 